package de.ozgcloud.eingang.enterprise.entry;

import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.*;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.ResultActions;

import de.ozgcloud.common.test.ITCase;
import de.ozgcloud.common.test.TestUtils;
import de.ozgcloud.eingang.router.VorgangService;
import lombok.SneakyThrows;

@ITCase
@AutoConfigureMockMvc
@ActiveProfiles({ "itcase", "local" })
class EnterpriseEntryITCase {

	@MockBean
	private VorgangService vorgangService;

	@Autowired
	private MockMvc mockMvc;

	@Test
	void shouldCallVorgangService() {
		doPostRequest();

		verify(vorgangService).createVorgang(any());
	}

	@SneakyThrows
	private ResultActions doPostRequest() {
		return mockMvc.perform(multipart("/antrag")
				.file(new MockMultipartFile("formData", TestUtils.loadTextFile("request/simple.json").getBytes())))
				.andExpect(status().is2xxSuccessful());
	}
}
